REM Verify 8 bit checksum
REM ---------------------
REM (C) 2014 by Martin Hoffmann-Vetter
REM This checksum is used to verify the correct rom content of FDC rom!

Function AscAt(s, n)
	AscAt = Asc(Mid(s, n, 1))
End Function

Function HexAt(s, n)
	HexAt = Hex(AscAt(s, n))
End Function

If WScript.Arguments.Count = 0 Then
	WScript.Echo "ERROR: Missing file name!"
	WScript.Quit 2
Else
	Result = True

	Dim FS, Datei
	Set FS = CreateObject( "Scripting.FileSystemObject" )

	For Each Filename In WScript.Arguments
		If Not FS.FileExists(FileName) Then
			WScript.Echo "ERROR: The file '" & FileName & "' is missing!"
			WScript.Quit 3
		Else
			Set Datei = FS.OpenTextFile( FileName, 1 )
			Sum = 0 : Size = 0

			Do Until Datei.AtEndOfStream
				Buffer = Datei.Read(16)

				Size = Size + Len(Buffer)
				For I = 1 TO Len(Buffer)
					Sum = Sum + AscAt(Buffer, I)
					If (Sum > 255) Then Sum = Sum - 255
				Next
			Loop

			Datei.Close
			Set Datei = Nothing

			Okay = Sum = (256 - (Size \ 256))
			Result = Result And Okay
			If Okay Then
				WScript.Echo Filename & " (" & Size & " Bytes): Checksum " & Right( "000" & Hex(Sum), 2) & " is okay!"
			Else
				WScript.Echo "ERROR: " & Filename & " (" & Size & " Bytes): Checksum " & Right( "000" & Hex(Sum), 2) & " is wrong!"
			End If
		End If
	Next

	Set FS = Nothing
	WScript.Quit 1 + CInt(Result)
End If