    .ifdef DOS25
     .if     .def(SPEEDOS)         ; All Speedos versions
CS_PTR      = L0026
     .elseif .def(DOS27)           ; All other DOS 2.7 versions
CS_PTR      = RIOT_RAM
     .else                         ; All DOS 2.5 versions
CS_PTR      = IP
     .endif
    .endif

INIT:       ldx #$3F               ; A2 3F
            txs                    ; 9A
            cld                    ; D8

    .ifndef DOS25
     .ifdef DOS1
            ldx #$FF               ; A2 FF
     .else
            stx TICK
     .endif
    .endif

    .ifdef DOS25
     .ifdef SPEEDOS
            ldy #0
     .else
            lda #0
            tay
      .ifndef DOS27
            sta VIA_T1LL
      .endif
            ldx #$3F
     .endif

     .ifdef DOS25
LC379:      txa
            sta RIOT_RAM,X
            dex
            bpl LC379

      .ifdef SPEEDOS
            tsx
      .else
            ldx #$3F
      .endif

LC381:      inc RIOT_RAM,X
            iny
            bne LC381
            txa
            cmp RIOT_RAM,X
            bne LC3B2

      .ifdef DOS27
            eor RIOT_RAM,X
            sta RIOT_RAM,X
            lda RIOT_RAM,X
            bne LC3B2
      .endif

            dex
            bpl LC381
     .endif
    .endif

    .ifndef DOS1
     .ifndef DOS27
      .ifdef DOS25
            ldx #$3F
      .endif
            lda #0

LC3C5:      sta RIOT_RAM,x
            cmp RIOT_RAM,x
      .ifdef DOS25
            bne LC3B2
      .else
LC3C8:      bne LC3C8
            sta JOBS,X
      .endif
            dex
            bpl LC3C5
     .endif
    .endif

    .ifdef DOS25
     .ifdef SPEEDOS
            ldx #8
     .else
            inx                    ; X = 0
      .ifdef DOS27
            stx CS_PTR
      .endif
            stx CS_PTR+1
      .ifndef DOS27
            sta CS_PTR
      .endif
            tay
            ldx #4
     .endif
            clc
LC39F:      dec CS_PTR+1
LC3A1:      adc (CS_PTR),Y
            iny
            bne LC3A1
            dex
            bne LC39F
            adc #0
            cmp CS_PTR+1
            beq LC3B7

            ldy #$FE
     .ifdef DOS27
            .byte $2C
     .else
            jmp LFC06
     .endif

LC3B2:      ldy #$FF
            jmp LFC06

LC3B7:
     .ifdef DOS27
            stx RIOT_DDRB
            dex
     .else
            ldx #%11111111
     .endif
    .endif
    .ifndef DOS1
            stx VIA_VB
    .endif
    .ifndef DOS25
            stx VIA_VDDRB          ; All bits on this port are output
            stx CUTMT              ; 8E 02 04
    .endif
    .ifndef DOS1
            stx RIOT_EOUT          ; All bits on this port are output
     .ifndef DOS27
            stx FTNUM
     .endif
    .endif

    .ifdef DOS25
     .ifdef DOS27
            ldx #VB_PLLSYN+VB_MOTOR0+VB_MOTOR1+VB_TRK_S0B+VB_TRK_S0A+VB_TRK_S1B+VB_TRK_S1A
            stx VIA_VDDRB
     .else
            lda #VB_PLLSYN+VB_MOTOR0+VB_MOTOR1+VB_TRK_S0B+VB_TRK_S0A+VB_TRK_S1B+VB_TRK_S1A
            sta VIA_VDDRB
     .endif
    .endif

    .ifndef DOS27
     .ifdef DOS25
            lda #PB_SYNC+PB_DRV_DS+PB_DRV_SEL
     .else
            lda #PB_DRV_DS+PB_DRV_SEL
     .endif
            sta RIOT_DDRB          ; 85 83
    .endif

    .ifdef DOS1
            stx FTNUM              ; 86 1B
    .endif

    .ifdef DOS27
            ldx #PCR_RD_GCR
            stx VIA_PCR
    .else
            lda #PCR_RD_GCR
            sta VIA_PCR            ; 85 4C
    .endif

    .ifdef DOS1
            stx VIA_VB             ; 86 40
    .endif

    .ifndef DOS25
            lda #IFR_IRQ+IFR_CB1+IFR_CA1
            sta VIA_IER            ; 85 4E
    .endif

    .ifdef DOS27
            ldx #%00000001
            stx VIA_ACR
    .else
            lda #%00000001         ; A9 01
            sta VIA_ACR            ; 85 4B
    .endif

    .ifndef DOS25
            lsr A                  ; 4A
            sta VIA_T1LL           ; 85 44
            sta BUFPT              ; 85 16
     .ifdef DOS1
            sta JOB                ; 85 1E
            ldy #14                ; A0 0E
LFC28:      sta JOBS,Y             ; 99 03 04
            sta STEPS,Y            ; 99 05 00
            dey                    ; 88
            bpl LFC28              ; 10 F7
     .endif
    .endif

    .ifndef DOS27
     .ifdef DOS25
            lda #8-1               ; in 8192 us next interrupt for Micropolis drives (122 Hz)
     .else
            lda #16-1              ; in 16384 us next interruot for Shugart drives (61 Hz)
     .endif
            sta TICK               ; 8D 00 04
            sta RIOT_T8            ; 85 8F
    .endif

    .ifndef DOS25
            lda #ST_SPEED_OK       ; A9 80
            sta DRVST+0            ; 85 03
            sta DRVST+1            ; 85 04
    .endif

    .ifdef DOS27
            ldx #14
            stx DELAY
    .else
     .ifdef DOS25
            lda #14
     .else
            lda #50                ; A9 32
     .endif
            sta DELAY              ; 8D 01 04
    .endif

    .ifdef DOS25
     .ifdef DOS27
            ldx #45
            stx CUTMT
     .else
            lda #45
            sta CUTMT
     .endif
    .endif

    .ifdef DOS27
            ldx #>HDRS
            stx HDRPNT+1
    .else
            lda #>HDRS             ; A9 04
            sta HDRPNT+1           ; 85 19
    .endif

    .ifdef DOS27
            ldx #2
            lda RIOT_PB
            and #PB_SYNC           ; Check if PB_SYNC is connected to GND
            beq LC3E1              ; If connected to GND => 8250 with two heads
            dex                    ; Else => 8050 with only one head
LC3E1:      stx NSIDES             ; Store the number of heads as number of sides

            ldx #1
     .ifndef SPEEDOS               ; Speedos don't support format 2A (4040 mode)!
            lda RIOT_PB
            and #PB_HD_SEL         ; Check if PB_HD_SEL is connected to GND
            bne LC3ED              ; If not connected to GND => use QD format 2C (8050/8250)
            dex                    ; Else => use DD format 2A (4040)
LC3ED:
     .endif
            stx L04EA              ; Store 1 for format 2C and 0 for format 2A

     .ifndef SPEEDOS
            bne LC3F5              ; If format 2C is detected use PB_HD_SEL as output, else it's an input
            ldx #PB_DRV_DS+PB_DRV_SEL
            .byte $2C
LC3F5:
     .endif
            ldx #PB_HD_SEL+PB_DRV_DS+PB_DRV_SEL
            stx RIOT_DDRB

     .ifdef SPEEDOS
            ldx #6-1
     .else
            ldx #4-1
     .endif
            stx L04EE

     .ifdef SPEEDOS
      .if .def(PANA)               ; Matsushita (Panasonic)
            ldx #4-1               ; in 4096 us next interrupt for Matsushita drives (244 Hz)
      .elseif .def(MPI)            ; MPI
            ldx #6-1               ; in 6144 us next interrupt for MPI drives (183 Hz)
      .else                        ; Micropolis
            ldx #8-1               ; in 8192 us next interrupt for Micropolis drives (122 Hz)
      .endif
     .else
            ldx #6-1               ; in 6144 us next interrupt for 4040 (183 Hz)
            lda L04EA
            beq LC40A
            stx L04EE
            dex
            dex                    ; in 4096 us next interrupt for 8050/8250 (244 Hz)
LC40A:
     .endif
            stx TICK
            stx RIOT_T8
    .endif

    .ifdef DOS25
     .ifdef SPEEDOS
            jmp START
     .else
            jmp (STARTI)
     .endif
    .endif