            .segment "DATA"

TICK:       .res 1                 ; Interrupt interval counter
DELAY:      .res 1                 ; Delay constant drive motors (motor starts)
CUTMT:      .res 1                 ; Cutout constant drive motors (motor stops)
JOBS:       .res 15                ; Job queue for buffer (15 bytes for 15 buffers)

    .ifdef DOS1
TRKS:
    .endif
            .res 15                ; Job track table for buffer (15 bytes for 15 buffers, only used in DOS 1.x)

HDRS:       .res 8*15              ; (4 bytes for 4 header bytes, 8 bytes reserved for 15 buffers)

    .ifndef DOS1
; ===> Next data extend with DOS 2.0 <===

TAB1:       .res 4                 ; Number of sectors (4 bytes for 4 zones)

GAP1:       .res 1                 ; Size of gap after sector header

GAP2:       .res 1                 ; Minimum bytes between sectors (Used in Format)

VERNUM:     .res 1                 ; Version number (A or C, Not used)

ACTJOB:     .res 1                 ; Current job number
    .endif

    .ifdef DOS25
; ===> Next data extend with DOS 2.5 <===

PHASE:      .res 2                 ; Phase of stepper motor (2 bytes for 2 drives)

     .ifndef DOS27
STPTRK:
     .endif
            .res 2                 ; Number of steps per track (2 bytes for 2 drives, only used in DOS 2.5)

SYNDLY:     .res 1                 ; Delay on PLLSYN control after SY??? "Off page edge"
                                   ; = 3 for 3 loops (25 us) to check sync

WPSW:       .res 2                 ; Write protect switch (2 bytes for 2 drives)

LWPT:       .res 2                 ; Last state of write protect switch (0 = , PB_DRV_WPS = , 2 bytes for 2 drives)

PBI:        .res 1                 ; Block indentifier

CFLG2:      .res 1                 ; Common flag 2

     .ifdef DOS27
NSIDES:
     .endif
            .res 1                 ; Number of sides on the diskette

    .ifdef SPEEDOS
SPDVAR:
    .endif
            .res 1                 ; Speed measure

            .res 1                 ; Unused

            .res 1

TAB3:
     .ifdef DOS27
            .res 8                 ; Track for zone ranges
     .else
            .res 4                 ; Track for zone ranges

            .res 4
     .endif

            .res 7
SYNCS:      .res 1                 ;
            .res 42

     .ifdef DOS27
L04EA:
     .endif
            .res 1

     .ifdef DOS27
STEPS:
     .endif
            .res 2                 ; (2 bytes for 2 drives, only used in DOS 2.7)

     .ifdef DOS27
MINTRK_SIDE2:
     .endif
            .res 1                 ; (only used in DOS 2.7)

     .ifdef DOS27
L04EE:
     .endif
            .res 1                 ; (only used in DOS 2.7)

     .ifdef DOS25B
SYNCCNT:
     .endif
            .res 1                 ; (Only used in last Revision DOS 2.5)
    .endif

BUFF0       = $0500                ; Buffer 0
    .ifdef DOS1
L0543       = BUFF0+$43
    .endif
;    .ifndef SPEEDOS
;INIT        := BUFF0
;    .endif

BUFF1       = $0600                ; Buffer 1
BUFF2       = $0700                ; Buffer 2
BUFF3       = $0800                ; Buffer 3
BUFF4       = $0900                ; Buffer 4
BUFF5       = $0A00                ; Buffer 5
BUFF6       = $0B00                ; Buffer 6
BUFF7       = $0C00                ; Buffer 7
BUFF8       = $0D00                ; Buffer 8
BUFF9       = $0E00                ; Buffer 9
BUFF10      = $0F00                ; Buffer 10
BUFF11      = $1000                ; Buffer 11
BUFF12      = $1100                ; Buffer 12 (BAM drive 0)
BUFF13      = $1200                ; Buffer 13 (BAM drive 1)
BUFF14      = $1300                ; Buffer 14 (Work space BC)
