            .segment "ZEROPAGE"

CLOCK:      .res 1                 ; IRQ counter

    .ifdef DOS25
MTRCLK:     .res 1                 ; Motor Clock counts 16 CLOCK cycles (Only used in DOS 2.5 and above)
    .else
MTRCLK      = CLOCK
    .endif

MTRTM:      .res 2                 ; Motor timing drive (2 bytes for 2 drives)
DRVST:      .res 2                 ; Drive status (2 bytes for 2 drives)

;ST_SHUTDOWN = %00010000            ; shut down drive motor? 1=yes (Not used)
ST_MOTOR_ON = %00100000            ; drive motor 1=on (only used by Speedos)
ST_HEAD_STP = %01000000            ; head stepping 1=on
ST_SPEED_OK = %10000000            ; drive up to speed 1=no 

    .ifdef DOS27
STEPS2:
    .else
STEPS:
    .endif
            .res 2                 ; Steps to move to desired track (0 - 127, 2 bytes for 2 drives)

COW:        .res 1                 ; Buffer for irq/motor timing bits
WORK:       .res 1                 ; temporary workspace
    .ifdef SPEEDOS
L000A:      .res 2                 ; (2 bytes for 2 drives)
    .else
            .res 1

     .ifndef DOS27
DTRCK:
     .endif
            .res 1                 ; (Only used in DOS 2.5 and earlier)
    .endif

    .ifndef DOS25
DSECT:
    .endif
    .ifdef SPEEDOS
DSECT:
    .endif
            .res 1                 ; (Only used in DOS 1.x and DOS 2.0 or Speedos)

CSECT:      .res 1                 ; Last sector read

STAB:                              ; Current block header (ID1, ID2, track, sector and parity)
STAB_ID1:   .res 1                 ;   ID1
STAB_ID2:   .res 1                 ;   ID2
STAB_TRK:   .res 1                 ;   Track number
STAB_SEC:   .res 1                 ;   Sector number
STAB_CHK:   .res 1                 ;   Header checksum (parity)

DRIVE:      .res 1                 ; Current drive
TRACK:      .res 1                 ; Current track
NEXTS:      .res 1                 ; Next (optimal) sector to service
SECTR:      .res 1                 ; Highest sector number in current track
BUFPT:      .res 2                 ; Buffer pointer address (2 bytes for 2 drives)
HDRPNT:     .res 2                 ; Pointer to active values in header table (2 bytes for 2 drives)

    .ifdef DOS1
JOBNUM:     .res 1                 ; Storage of current job number (DC) (Only used in DOS 1.x)
    .endif

    .ifndef DOS27
FTNUM:
    .endif
            .res 1                 ; Track currently being formated (Only used in DOS 2.5 and earlier)

    .ifdef DOS25
IP:
    .endif
            .res 2                 ; Indirect Pointer (Only used in DOS 2.5 and later)

    .ifndef DOS1
     .ifdef DOS27
SYNCCNT:                           ; (Only used in DOS 2.7)
     .else
ERRCNT:                            ; Error counter if being formatting (Only used in DOS 2.0 and DOS 2.5)
     .endif
            .res 1
    .endif

JOB:        .res 1                 ; Temporary storage of job code

    .ifdef DOS1
ERRCNT:                            ; Error counter if being formatting (Only used in DOS 1.x)
    .else
JOBNUM:                            ; Storage of current job number (DC) (Only used in DOS 2.0 and later)
    .endif
            .res 1

    .ifdef DOS25
DRVTRK:     .res 2                 ; (2 bytes for 2 drives)
STPCNT:     .res 2                 ; (2 bytes for 2 drives)
CHKSUM2:    .res 1

     .if !(.def(DOS25B) || .def(DOS27))
BI:         .res 1                 ; (Only used in DOS 2.5 first Revision) 
            .res 1                 ; (Reserved)
     .elseif .def(SPEEDOS)
L0026:      .res 2                 ; (Only used in Speedos)
     .else
            .res 1
            .res 1                 ; (Reserved)
     .endif


NXTJOB:     .res 1
NXTRK:      .res 1
    .endif
